<template>
  <rui-list-item :caption="resource.name"
                 :sub-caption="resource.latinName"
                 :active="selectedId === resource.id"
                 :image="resource.picturePath"
                 @choose="$emit('choose', resource)">
    <template v-if="resourceInteractionsGroups.length > 0" #left>
      <rui-button size="large" text no-action>
        <rui-icon :name="interactionIcon.icon" :class="interactionIcon.css" />
      </rui-button>
    </template>
    <template #right>
      <rui-button v-if="children.length > 0"
                  icon="caret-circle-down"
                  text
                  @click="$emit('show-children', {name: resource.name, children})" />
      <rui-button icon="info"
                  variant="helping"
                  :title="$t('generic.info')"
                  text
                  @click="$emitBus('show-resource-description', resource)" />
    </template>
  </rui-list-item>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import Resource from '../../../../../classes/models/Resource'
import { NATURE_CSS, NATURE_ICONS } from '../../../../../app_helpers/resource_interactions_icons.js'

export default {
  name: 'GpaResourceSelectorResource',
  emits: [
    'choose',
    'show-children',
  ],
  components: { RuiIcon, RuiButton, RuiListItem },
  props: {
    resource: { required: true, type: Resource },
    children: { required: false, type: Array, default: () => [] },
    selectedId: { required: false, type: Number, default: null },
    resourceInteractionsGroups: { required: false, type: Array, default: () => [] },
  },
  computed: {
    interactions () { return this.resource.resourceInteractionsWithGroups(this.resourceInteractionsGroups) },
    interactionIcon () {
      let nature = 'unknown'

      for (const interaction of this.interactions) {
        if (interaction.isNeutral && interaction === 'unknown') nature = 'neutral'
        if (interaction.isPositive) nature = 'positive'
        if (interaction.isNegative) {
          nature = 'negative'
          break
        }
      }

      return { icon: NATURE_ICONS[nature], css: NATURE_CSS[nature] }
    },
  },
}
</script>
